Subject: bug#39067: closed (Re: bug#39067: shell-command-dont-erase-buffer strange behaviour)

From: [email-masked] (GNU bug Tracking System)
Date: Sun, 19 Jan 2020 10:20:02 +0000

Your bug report

#39067: shell-command-dont-erase-buffer strange behaviour

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
39067: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=39067
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#39067: shell-command-dont-erase-buffer strange behaviour
From: Tino Calancha <[email-masked]>
To: [email-masked]
Date: Sun, 19 Jan 2020 11:19:19 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

Michael Albinus <[email-masked]> writes:

Fixed the bug into emacs-27 branch with commit:
'Fix shell-command-dont-erase-buffer feature'
(2eb0b7835d1a9cd4b804436e33c71058cb38f178)

> I haven't tested yet, but some minor nits:
Thank Michael for the corrections!  I have added then but this one:

> ;; successive commands know the position where the new command starts.
>
>> +          ;; (unless (and pos (memq sym '(save-point beg-last-out)))
>
> This is superfluous, isn't it?
That is requred for a corner case: one of the new tests fails if I
remove that.

Subject: shell-command-dont-erase-buffer strange behaviour
From: Madhu <[email-masked]>
To: [email-masked]
Date: Fri, 10 Jan 2020 05:34:18 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

C-h v shell-command-dont-erase-buffer
C-h f shell-command

Cut to the chase with the test case:

(let ((shell-command-dont-erase-buffer 'beg-last-out))
  (with-current-buffer (get-buffer-create "OUT")
    (erase-buffer)
    (shell-command "/bin/echo FOO" t)
    (shell-command "/bin/echo FOO" t)))

The result (as expected) is a buffer named OUT with 2 lines FOO.
The same result is expected with the following code:

(let ((shell-command-dont-erase-buffer 'beg-last-out))
  (with-current-buffer (get-buffer-create "OUT")
    (erase-buffer)
    (shell-command "/bin/echo FOO" "OUT")
    (shell-command "/bin/echo FOO" "OUT")))

However in this case (and in some other cases) shell-command erases the
"OUT" buffer despite a non-NIL binding of
shell-command-dont-erase-buffer

(at least since emacs 25.2)